pro drawvectors_all,xmax,xmin,ymax,ymin,mg,jg2,along,alat2,udata,vdata,maxmag,nh,color

; mg is number of lons
; jg2 is number of lats
; along is longitude values
; alat2 is latitude values
; udata, vdata are wind fields
; maxmag is scale factor (try 3; larger=shorter)
; nh = +1 for Northern Hemisphere polar plot
; nh = -1 for Southern Hemisphere polar plot
; nh =  0 for Mercator
help,xmax,xmin,ymax,ymin,mg,jg2,along,alat2,udata,vdata,maxmag,nh,color

;C draw vectors
    loninc=intarr(jg2)
    loninc(*)=1
    if nh ne 0 then begin
      jg=jg2/2
      for j=0,jg-1 do begin
        loninc(j)=mg/(4*(j+1))
        loninc(jg2-1-j)=mg/(4*(j+1))
      endfor
index=where(loninc lt 2)
if index(0) ne -1 then loninc(index)=2
    endif
    sina = udata/maxmag
    cosa = vdata/maxmag
    for j=0,jg2-1 do begin
      for i=0,mg-1 do begin
        x0=along(i)
        y0=alat2(j)
        if x0 le xmax and x0 ge xmin and y0 le ymax and y0 ge ymin then begin
        dx = sina(i,j)
        dy = cosa(i,j)
        if dx ge 999. then goto, clipdata
        size = sqrt(dx*dx+dy*dy)
        arr = .25
        st = arr*.38268
        ct = arr*.92387
        x1 = x0 + dx
        y1 = y0 + dy
        if (nh eq 0) and (x0 ge 90. or x1 ge 90.) and $
         (y0 le -80 or y1 le -80) then goto, jumplab
        oplot,[x0,x1],[y0,y1],color=color
        oplot,[x1,x1-(ct*dx-st*dy)],[y1,y1-(ct*dy+st*dx)],color=color
        oplot,[x1,x1-(ct*dx+st*dy)],[y1,y1-(ct*dy-st*dx)],color=color
jumplab:
clipdata:
      endif
      endfor
    endfor
!p.thick=1
end
