; Run parameters are hardwired in "setup" section of main program below!
;

pro read_trajectory_output_v24, xn,yn,zn,pvn,pn,thn,un,vn,sn,$
         frday,frnght,thdn,qdfn,xmsfn,xmrkn,sstn,chln,lndn,$
         t0n,agen,xmintn, $
         tmpn,altn,ntraj, $
         ntracers, tracern, $
         ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
         idms, ich2o, ilnox, icmflx, $
         ico, ibro, iso4, idust,$
         issalt,ibcoc,ico25d


; trajectory variables:

;        xn             longitude
;        yn             latitude
;        zn             eta
;        pvn            PV
;        pn             p
;        thn            theta
;        un             uwind
;        vn             vwind
;        frday          fracday
;        frnght         fracnight
;        thdn           Convective mass flux
;        qdfn           QDF
;        xmsfn          MSF
;        xmrkn          Marker field: PBL(-1), FT(0), or strat.(1)
;        t0n            initial time
;        agen           age
;        xmintn         min temp.

; diagnose temperature
;        tmpn(index)=thn(index)*(pn(index)/1000.)^.286

; diagnose altitude
;        altn(index)=(xmsfn(index)-tmpn(index)*cp)/g   ; m


        xn=fltarr(ntraj)
        yn=fltarr(ntraj)
; zn = eta level
        zn=fltarr(ntraj)
        pvn=fltarr(ntraj)
        pn=fltarr(ntraj)
; thn = potential temperature        tdf 11/08/2K4
        thn=fltarr(ntraj)
; un/vn u and v wind                 rbp 08/24/2016
        un=fltarr(ntraj)
        vn=fltarr(ntraj)

        frday=fltarr(ntraj)
        frnght=fltarr(ntraj)
; thdn = theta-dot, eliminating qn   tdf 11/08/2K4
        thdn=fltarr(ntraj)
        qdfn=fltarr(ntraj)
; Montgomery S.F.                    tdf 11/08/2K4
        xmsfn=fltarr(ntraj)
; PBL/FT/strat marker
        xmrkn=fltarr(ntraj)
; SST/CHL External data
        sstn=fltarr(ntraj)
        chln=fltarr(ntraj)
        lndn=fltarr(ntraj)

        t0n=fltarr(ntraj)
        agen=fltarr(ntraj)
        xmintn=fltarr(ntraj)

; Add generalized tracer array       JAA 2006/01/23
        dummyn=fltarr(ntraj)
        tracern=fltarr(ntracers,ntraj)

    char1='     '
    char2='     '
    char3='     '
    char4='     '
    char5='     '
    char6='      '
    char7='      '
    char8='      '
    char9='       '
    char10='       '
    char11='       '
    char12='      '
    char13='      '
    char14='       '
    char15='     '
    char16='       '
    char17='       '
    char18='       '
    char19='        '
    char20='         '
    char00='         '

; read trajectory output
        readu,12,char1
        READU,12,xn
        readu,12,char2
        READU,12,yn
        readu,12,char3
        READU,12,zn
        readu,12,char4
        READU,12,pvn
        readu,12,char5
        READU,12,pn
        readu,12,char6
; thn = potential temperature        tdf 11/08/2K4
        READU,12,thn
        readu,12,char5
; un = uwind                         rbp 08/24/2016
        READU,12,un
        readu,12,char5
; vn = vwind                         rbp 08/24/2016
        READU,12,vn
        readu,12,char7
        READU,12,frday
        readu,12,char8
        READU,12,frnght
        readu,12,char9
; thdn = theta-dot, eliminating qn   tdf 11/08/2K4
        READU,12,thdn
        readu,12,char10
        READU,12,qdfn
        readu,12,char11
; xmsfn = Montgomery S.F             tdf 11/08/2K4
        READU,12,xmsfn
        readu,12,char11
; xmrkn = PBL/FT/strat marker        tdf 11/08/2K4
        READU,12,xmrkn
index=where(xmrkn ge .99,counts)
index=where(xmrkn lt 0.,countp)
;print,char11
;print,'nstrat,npbl',counts,countp
        readu,12,char10
        READU,12,sstn
        readu,12,char10
        READU,12,chln
;print,max(sstn),min(sstn)
;print,max(chln),min(chln)
lndn=0.*chln
index=where(chln lt 0.)
lndn(index)=1.
;index=where(chln ge 0.)
;!psym=3
;plot,sstn(index),chln(index)
;help,ntraj,index
;stop
        readu,12,char18
        READU,12,t0n
        readu,12,char19
        READU,12,agen
        readu,12,char20
        READU,12,xmintn

; Add generalized tracer array       JAA 2006/01/23
        ih2o=-1L
        iox=-1L
        inoy=-1L
        ipan=-1L
        inox=-1L
        ioxprod=-1L
        iphytndox=-1L
        iwetdepox=-1L
        idms=-1L
        ich2o=-1L
;        inoyprod=-1L
;        iphytndnoy=-1L
;        iwetdepnoy=-1L
        ilnox=-1L
        icmflx=-1L
        ico=-1L
        ibro=-1L
        iso4=-1L
        idust=-1L
        issalt=-1L
        ibcoc=-1L
        ico25d=-1L
        for m=0L,ntracers-1L do begin
          readu,12,char00
          print,'Tracer ',m+1,' ',char00
          readu,12,dummyn
          print,max(dummyn),min(dummyn)
          tracern(m,*) = dummyn(*)
          test=strtrim(char00,2)
          case 1 of
            test eq 'iq': ih2o=m
            test eq 'iox': iox=m
            test eq 'inoy': inoy=m
            test eq 'ipan': ipan=m
            test eq 'inox': inox=m
            test eq 'oxprod': ioxprod=m
            test eq 'phytndox': iphytndox=m
            test eq 'wetdepox': iwetdepox=m
            test eq 'lnox': ilnox=m
            test eq 'cmflx': icmflx=m
            test eq 'ico': ico=m
            test eq 'bro': ibro=m
            test eq 'iso4aer': iso4=m
            test eq 'idust': idust=m
            test eq 'issalt': issalt=m
            test eq 'ibcoc': ibcoc=m
            test eq 'idms': idms=m
            test eq 'ich2o': ich2o=m
            test eq 'ico25d': ico25d=m
            else: stop, 'Read undefined tracer, '+test
          endcase
        endfor
print,ih2o,iox,inoy,ipan,inox,ioxprod,iphytndox,iwetdepox,ilnox,icmflx,ico,ibro,iso4,idust,issalt,ibcoc,idms,ich2o,ico25d
        dummyn = 0.
;        stop

; define temperature
;
        tmpn=9999.+0*thn
        index=where(thn lt 9999. and pn lt 9999.)
        tmpn(index)=thn(index)*(pn(index)/1000.)^.286
; define windspeed
;
        sn=9999.+0*un
        index=where(un lt 9999. and pn lt 9999.)
        sn(index)=sqrt(un(index)^2+vn(index)^2)

; define altitude
        cp = 1004.  ; J /K /kg
        g = 9.81    ; m / s^2
        altn=99999.+0*zn
        altn(index)=(xmsfn(index)-tmpn(index)*cp)/g   ; m
help,thn,tmpn,altn
;stop
return
end

pro read_trajectory_output_v23, xn,yn,zn,pvn,pn,thn,un,vn,sn,$
         frday,frnght,thdn,qdfn,xmsfn,xmrkn,$
         t0n,agen,xmintn, $
         tmpn,altn,ntraj, $
         ntracers, tracern, $
         ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
         iassm3dox, iassmcolox, inoyprod, iphytndnoy, iwetdepnoy, ilnox, icmflx, $
         ico, ibro, iso4, idust,$
         issalt,ibcoc


; trajectory variables:

;        xn             longitude
;        yn             latitude
;        zn             eta
;        pvn            PV
;        pn             p
;        thn            theta
;        un             uwind
;        vn             vwind
;        frday          fracday
;        frnght         fracnight
;        thdn           Convective mass flux
;        qdfn           QDF
;        xmsfn          MSF
;        xmrkn          Marker field: PBL(-1), FT(0), or strat.(1)
;        t0n            initial time
;        agen           age
;        xmintn         min temp.

; diagnose temperature
;        tmpn(index)=thn(index)*(pn(index)/1000.)^.286

; diagnose altitude
;        altn(index)=(xmsfn(index)-tmpn(index)*cp)/g   ; m


        xn=fltarr(ntraj)
        yn=fltarr(ntraj)
; zn = eta level
        zn=fltarr(ntraj)
        pvn=fltarr(ntraj)
        pn=fltarr(ntraj)
; thn = potential temperature        tdf 11/08/2K4
        thn=fltarr(ntraj)
; un  = u wind                       rbp 08/24/2016
        un=fltarr(ntraj)
; vn  = v wind                       rbp 08/24/2016
        vn=fltarr(ntraj)

        frday=fltarr(ntraj)
        frnght=fltarr(ntraj)
; thdn = theta-dot, eliminating qn   tdf 11/08/2K4
        thdn=fltarr(ntraj)
        qdfn=fltarr(ntraj)
; Montgomery S.F.                    tdf 11/08/2K4
        xmsfn=fltarr(ntraj)
; PBL/FT/strat marker
        xmrkn=fltarr(ntraj)
        t0n=fltarr(ntraj)
        agen=fltarr(ntraj)
        xmintn=fltarr(ntraj)

; Add generalized tracer array       JAA 2006/01/23
        dummyn=fltarr(ntraj)
        tracern=fltarr(ntracers,ntraj)

    char1='     '
    char2='     '
    char3='     '
    char4='     '
    char5='     '
    char6='      '
    char7='      '
    char8='      '
    char9='       '
    char10='       '
    char11='       '
    char12='      '
    char13='      '
    char14='       '
    char15='     '
    char16='       '
    char17='       '
    char18='       '
    char19='        '
    char20='         '
    char00='         '

; read trajectory output
        readu,12,char1
        READU,12,xn
        readu,12,char2
        READU,12,yn
        readu,12,char3
        READU,12,zn
        readu,12,char4
        READU,12,pvn
        readu,12,char5
        READU,12,pn
        readu,12,char6
; thn = potential temperature        tdf 11/08/2K4
        READU,12,thn
        readu,12,char6
; un = u wind                        rbp 08/24/2016
        READU,12,un
        readu,12,char6
; vn = v wind                        rbp 08/24/2016
        READU,12,vn
        readu,12,char7
        READU,12,frday
        readu,12,char8
        READU,12,frnght
        readu,12,char9
; thdn = theta-dot, eliminating qn   tdf 11/08/2K4
        READU,12,thdn
        readu,12,char10
        READU,12,qdfn
        readu,12,char11
; xmsfn = Montgomery S.F             tdf 11/08/2K4
        READU,12,xmsfn 
        readu,12,char11
; xmrkn = PBL/FT/strat marker        tdf 11/08/2K4
        READU,12,xmrkn 
index=where(xmrkn ge .99,counts)
index=where(xmrkn lt 0.,countp)
print,char11
print,'nstrat,npbl',counts,countp
        readu,12,char18
        READU,12,t0n
        readu,12,char19
        READU,12,agen
        readu,12,char20
        READU,12,xmintn

; Add generalized tracer array       JAA 2006/01/23
        ih2o=-1L
        iox=-1L
        inoy=-1L
        ipan=-1L
        inox=-1L
        ioxprod=-1L
        iphytndox=-1L
        iwetdepox=-1L
        iassm3dox=-1L
        iassmcolox=-1L
        inoyprod=-1L
        iphytndnoy=-1L
        iwetdepnoy=-1L
        ilnox=-1L
        icmflx=-1L
        ico=-1L
        ibro=-1L
        iso4=-1L
        idust=-1L
        issalt=-1L
        ibcoc=-1L
        for m=0L,ntracers-1L do begin
          readu,12,char00
;          print,'Tracer ',m+1,' ',char00
          readu,12,dummyn
          tracern(m,*) = dummyn(*)
          test=strtrim(char00,2)
          case 1 of
            test eq 'iq': ih2o=m
            test eq 'iox': iox=m
            test eq 'inoy': inoy=m
            test eq 'ipan': ipan=m
            test eq 'inox': inox=m
            test eq 'oxprod': ioxprod=m
            test eq 'phytndox': iphytndox=m
            test eq 'wetdepox': iwetdepox=m
            test eq 'assm3dox': iassm3dox=m
            test eq 'assmcolox': iassmcolox=m
            test eq 'noyprod': inoyprod=m
            test eq 'phytndnoy': iphytndnoy=m
            test eq 'wetdepnoy': iwetdepnoy=m
            test eq 'lnox': ilnox=m
            test eq 'cmflx': icmflx=m
            test eq 'ico': ico=m
            test eq 'bro': ibro=m
            test eq 'iso4aer': iso4=m
            test eq 'idust': idust=m
            test eq 'issalt': issalt=m
            test eq 'ibcoc': ibcoc=m
            else: stop, 'Read undefined tracer, '+test
          endcase
        endfor
        dummyn = 0.
;        stop

; define temperature
;
        tmpn=9999.+0*thn
        index=where(thn lt 9999. and pn lt 9999.)
        tmpn(index)=thn(index)*(pn(index)/1000.)^.286
; define wind speed
;
        sn=9999.+0*un
        index=where(un lt 9999. and pn lt 9999.)
        sn(index)=sqrt(un(index)^2+vn(index)^2)

; define altitude
        cp = 1004.  ; J /K /kg
        g = 9.81    ; m / s^2
        altn=99999.+0*zn
        altn(index)=(xmsfn(index)-tmpn(index)*cp)/g   ; m
return
end

pro post_process_region_v24_gentracers_anal

; program post_process_intex_region.pro
; This program processes regional back trajectory
; files. It produces a sequence of daily output files
; of 3D products. This program is built from
; post_process_tracep_curtain.pro
;                                         tdf 9/19/2K5 
; version for GFS_v23 regional simulations
; This version does NH from 0 to 70 N
;
; Modified to process arbitrary number of tracers JAA 2006/01/25

; The following diagnostics are currently output:

; x     - longitude
; y     - latitude
; p     - pressure
; tmp   - temperature
; pv    - PV
; age    - parcel age
; pvmax   - Lagrangian max PV
;       V6 update:  Lagrangian maximum PV, where P<500mb  tdf 8/4/2K5
; alt     - altitude
; tracer(0:ntracers) - Lagrangian ave tracers
; 

;spawn,'ls -1 ../*traj > trajfiles.dat '

;;;
;;;  Begin run setup
;;;

;!!!! WARNING: hard wired for nx,ny,nz
; CONUS regional
;nx=25l
;ny=16l
;nz=14l
; 0->70N band: 2x2, 21 levels
;nx=180l
;ny=36l
;nz=21l
;lons=0.+2.*findgen(nx)
;lats=0.+2.*findgen(ny)
; TEXAQS 6 levels
nx=240l
ny=121l
nz=6l
lons=235.+0.25*findgen(nx)
lats=20.+0.25*findgen(ny)
; ARCPAC Hemispheric 6 levels
nx=360l
ny=66l
nz=6l
lons=1.*findgen(nx)
lats=25.+1.*findgen(ny)
; ARCPAC AK local 14 levels
nx=360l
ny=121l
nz=15l
lons=165.+.25*findgen(nx)
lats=50.+.25*findgen(ny)
; ARCPAC CONUS local 14 levels
nx=360l
ny=121l
nz=15l
lons=210.+.25*findgen(nx)
lats=20.+.25*findgen(ny)
; 2015 CONUS local 14 levels
nx=281l
ny=121l
nz=15l
lons=225.+.25*findgen(nx)
lats=22.+.25*findgen(ny)
; 2016 TRANSIT
nx=241l
ny=181l
nz=15l
lons=195.+.25*findgen(nx)
lats=15.+.25*findgen(ny)
; 2016 TRANSIT Large Domain
nx=721l
ny=181l
nz=15l
lons=75.+.25*findgen(nx)
lats=15.+.25*findgen(ny)
; 2016 KORUS-AQ Small Domain
nx=151l
ny=151l
nz=15l
lons=120.+.1*findgen(nx)
lats=30.+.1*findgen(ny)


do_pannoy='y'
do_noxnoy='y'
do_vocage='n'
do_bioage='n'

; Trajectory output directory:
cdir='/odyssey/proxy/bpierce/KORUS-AQ/UW-Hybrid_traject/'

idir=cdir+'Trajectory/'
odir=cdir+'Lagrangian_averaged/'

close,1
openr,1,'trajfiles_korus-aq.fil'

;;;
;;;  End run setup
;;;

nruns=0L
ifilet=''
readf,1,nruns

for nn=0L,nruns-1L do begin
    readf,1,ifilet
    close,12
    openr,12,idir+ifilet,/f77

    print,ifilet

label=strmid(ifilet,6,11)
print,label
;
    nmax=600000l
    nrmax=181
    ncmax=361
    x=fltarr(ncmax)
    y=fltarr(nrmax)
;
    charexp='                                   '                         
    nthp=0L
    ukmo=' '
    nmc=' '
    ecmwf=' '
    restart=' '
    rfile='                                     '
    nrday=0
    dir='                                       '                             
    nfile=0
    wfile='                                               '
    istime=0l
    ictime=0l
    dtflow=0.                          
    dt=0.                              
    igw=' '                             
    stream=' '                          
    nstrm=0                           
    ds1=0.                             
    strm0=0.                           
    dstrm=0.                           
    pviso=' '
    npviso=0                          
    ds2=0.                             
    pv0=0.                             
    dpv=0.                             
    tiso=' '                            
    ntiso=0                           
    ds3=0.                             
    temp0=0.                           
    dtemp=0.
    space=' '
    dxs=0.                             
    dys=0.                             
    henry=' '
    dirh='                                     '
    hfile='                                     '
    range_fill=' '
    stlat=0.
    stlon=0.
    er2_range=' '
    nrings=0L
    npts=0L
    dial=' '
    dird='                                     '
    ndial=0l 
    dfile='                                     '
; new option curtain             tdf 4/19/2K5
    curtain=' '
    dirc='                                      '
    ncurt=0l 
    cfile='                                     '
; new option curtain             tdf 4/19/2K5
    er2=' '                             
    nleg=0                            
    xleg0=0.
    yleg0=0.
    xleg1=0.
    yleg1=0.
    dc8=' '
    dirdc8='/usr73/SOLVEII/DIAL_data/Datfiles/'
    ndc8=0L
    dc8file='dial_o3_20000309.diag.dc8'
    dtout=0.                           
    ofile='                                          '
    nr=0
    nc=0
    time=0.
    ntraj=0l
    ntracers=0l
;
;  read input parameters for this experiment
;
    readu,12,charexp
;print,'charexp=',charexp
    readu,12,nthp       ; these are now eta surfaces
    thlevp=fltarr(nthp)
    readu,12,thlevp
;print,'thlevp=',thlevp
    readu,12,ukmo
    readu,12,nmc
    readu,12,ecmwf
    readu,12,restart
    readu,12,rfile
    readu,12,nrday
    readu,12,dir
    readu,12,nfile
    wfiles=strarr(nfile)
    for n=0,nfile-1 do begin
        readu,12,wfile
        wfiles(n)=strtrim(wfile)
        ;print,' wfile =',wfile
    endfor
    readu,12,istime
    readu,12,dtflow                          
    readu,12,dt                              
    readu,12,igw                             
    readu,12,stream                          
    readu,12,nstrm                           
    readu,12,ds1                             
    readu,12,strm0                           
    readu,12,dstrm                 
    readu,12,pviso                           
    readu,12,npviso                          
    readu,12,ds2                             
    readu,12,pv0                             
    readu,12,dpv                             
    readu,12,tiso                            
    readu,12,ntiso                           
    readu,12,ds3                             
    readu,12,temp0                           
    readu,12,dtemp                           
    readu,12,space                           
    readu,12,dxs                             
    readu,12,dys                             
; added new parameter  tdf
    readu,12,henry
    readu,12,dirh
    readu,12,hfile
; added new parameter
    readu,12,range_fill
    readu,12,stlat
    readu,12,stlon
    readu,12,er2_range
    readu,12,nrings
    readu,12,npts
    readu,12,dial
    readu,12,dird
    readu,12,ndial
    for n=1,ndial do begin 
        readu,12,dfile
        ;print , n, dfile 
    endfor 
; new option curtain             tdf 4/19/2K5
    readu,12,curtain
    readu,12,dirc
    ;print,' dirc =',dirc
    readu,12,ncurt
    for n=1,ncurt do begin 
        readu,12,cfile
        ;print , n, cfile 
    endfor 
; new option curtain             tdf 4/19/2K5
    readu,12,er2                             
    readu,12,nleg                            
    for n=1,nleg do begin                             
        readu,12,xleg0
        readu,12,yleg0
        readu,12,xleg1
        readu,12,yleg1
    endfor                                    
    readu,12,dc8
    readu,12,dirdc8
    readu,12,ndc8
    for n=1,ndc8 do begin
        readu,12,dc8file
;        ;print , n,dc8file
    endfor
    readu,12,dtout                           
    readu,12,ofile
    ;print,ofile
    print,'    Header read ok'

    wtime=dtflow*findgen(nfile)

    nfiles=40    ; maximum 5 days at 3 hour interval 
;***** Problem: sometimes no trajectories are output
; solve this by keeping track of output times  
;                                       tdf 5/10/2K5
times=fltarr(nfiles)

  ; loop over files
  for n=0,nfiles-1 do begin

    if (EOF(12)) then goto, fend
        READU,12,istime,ictime,time,ntraj,ntracers
        print,n,istime,ictime,time,ntraj,ntracers
;
        stime=strcompress(string(istime),/remove_all)
        mdate=long(strmid(stime,0,8))
;
        times(n) = time
;
read_trajectory_output_v24, xn,yn,zn,pvn,pn,thn,un,vn,sn,$
         frday,frnght,thdn,qdfn,xmsfn,xmrkn,sstn,chln,lndn,$
         t0n,agen,xmintn, $
         tmpn,altn,ntraj, $
         ntracers, tracern, $
         ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
         idms, ich2o, ilnox, icmflx, $
         ico, ibro, iso4, idust,$
         issalt,ibcoc,ico25d
;read_trajectory_output_v23, xn,yn,zn,pvn,pn,thn,$
;         frday,frnght,thdn,qdfn,xmsfn,xmrkn,$
;         t0n,agen,xmintn, $
;         tmpn,altn,ntraj, $
;         ntracers, tracern, $
;         ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
;         iassm3dox, iassmcolox, inoyprod, iphytndnoy, iwetdepnoy, ilnox, icmflx, $
;         ico, ibro, iso4, idust,$
;         issalt,ibcoc

print,ntracers
;Note: tracern is fltarr(ntracers,ntraj)
;help,tracern
;print,min(tracern),max(tracern)
;stop

;JAA 2005/11/16 don't allow bogus pv values, eg 10^14
; check=where(pvn gt 9999.,count)
; if count gt 0 then pvn(check)=0.0

;JAA 2005/11/16 don't allow pan > noy
if inoy ge 0 then tracern(inoy,*) = tracern(inoy,*) > 0.
if ipan ge 0 then begin
  tracern(ipan,*) = tracern(ipan,*) > 0.
  tracern(ipan,*) = tracern(ipan,*) < tracern(inoy,*)
endif
if inox ge 0 then begin
  tracern(inox,*) = tracern(inox,*) > 0.
  tracern(inox,*) = tracern(inox,*) < tracern(inoy,*)
endif

print,'read trajectories'
print,'Number of trajectories: ',ntraj
print,'Number of tracers: ',ntracers

; recall that the first output has the FULL number of trajectories

; INITIAL conditions
        ;if ictime ge istime then begin
        if n eq 0 then begin
;
; initial locations
           x0=xn
           y0=yn
           z0=zn
           p0=pn
           u0=un
           v0=vn

print,'nx*ny*nz,ntraj',nx*ny*nz,ntraj
;stop
;
; initialise save arrays (Variables to be output as instantaneous)
           xsave=fltarr(nfiles,ntraj)*0.0+9999.
           ysave=fltarr(nfiles,ntraj)*0.0+9999.
           psave=fltarr(nfiles,ntraj)*0.0+9999.
;rbp           ssave=fltarr(nfiles,ntraj)*0.0+9999.

           tmpsave=fltarr(nfiles,ntraj)*0.0+9999.
           altsave=fltarr(nfiles,ntraj)*0.0+9999.  ; altitude
;           pvsave=fltarr(nfiles,ntraj)*0.0+9999.
;           qdfsave=fltarr(nfiles,ntraj)*0.0+9999.
           agesave=fltarr(nfiles,ntraj)*0.0+9999.

           ;extras
           ;;; zsave=fltarr(nfiles,ntraj)
           ;;; thsave=fltarr(nfiles,ntraj)
           ;;; frdaysave=fltarr(nfiles,ntraj)
           ;;; frnghtsave=fltarr(nfiles,ntraj)
           ;;; thdsave=fltarr(nfiles,ntraj)
           ;;; xmsfsave=fltarr(nfiles,ntraj)
           ;;; t0save=fltarr(nfiles,ntraj)
           ;;; mintsave=fltarr(nfiles,ntraj)


; Initialize sum and avesave arrays (Variables to be output as time-averaged)
;  Note pvmax is accumulated in similar arrays but is not time-averaged.
;  All tracers are currently time-averaged
           pvsum=0.0*pvn
           qdfsum=0.0*qdfn 
           ssum=0.0*sn
           pvmax=0.0*pvn
;
           pvavesave=fltarr(nfiles,ntraj)*0.0+9999.
           qdfavesave=fltarr(nfiles,ntraj)*0.0+9999.
           savesave=fltarr(nfiles,ntraj)*0.0+9999.
           pvmaxsave=fltarr(nfiles,ntraj)*0.0+9999.
;
           tracersum = fltarr(ntracers,ntraj)
           traceravesave = fltarr(nfiles,ntracers,ntraj)*0.0+9999.

; Initialize marker-related arrays for pbl and strat flags (template is pvmax)
           stratsum=0.0*xmrkn
           pblconussum=0.0*xmrkn
           pbltropicssum=0.0*xmrkn
           pbleasiasum=0.0*xmrkn
           pblsum=0.0*xmrkn
;
           stratavesave=fltarr(nfiles,ntraj)*0.0+9999.
           pblconusavesave=fltarr(nfiles,ntraj)*0.0+9999.
           pbltropicsavesave=fltarr(nfiles,ntraj)*0.0+9999.
           pbleasiaavesave=fltarr(nfiles,ntraj)*0.0+9999.
           pblavesave=fltarr(nfiles,ntraj)*0.0+9999.

; PAN/NOy, NOx/NOy
           ntracerout = ntracers
           ipannoy = -1L
           inoxnoy = -1L
           ivocage = -1L
           ibioage = -1L
           if do_pannoy eq 'y' and ipan ge 0 then begin
             pannoysum=fltarr(ntraj)
             pannoyavesave=fltarr(nfiles,ntraj)*0.0+9999.
             ipannoy = ntracerout
             ntracerout=ntracerout+1L
           endif
           if do_noxnoy eq 'y' and inox ge 0 then begin
             noxnoysum=fltarr(ntraj)
             noxnoyavesave=fltarr(nfiles,ntraj)*0.0+9999.
             inoxnoy = ntracerout
             ntracerout=ntracerout+1L
           endif
;           if do_vocage eq 'y' and ic2h6 ge 0 then begin
;             vocagesum=fltarr(ntraj)
;             vocageavesave=fltarr(nfiles,ntraj)*0.0+9999.
;             ivocage = ntracerout
;             ntracerout=ntracerout+1L
;           endif
;           if do_bioage eq 'y' and ich2o ge 0 then begin
;             bioagesum=fltarr(ntraj)
;             bioageavesave=fltarr(nfiles,ntraj)*0.0+9999.
;             ibioage = ntracerout
;             ntracerout=ntracerout+1L
;           endif


           number = fltarr(ntraj) ; number used to compute average PV
                                  ; (to ignore bogus PV values)

        endif
; end initial conditions


; Save daily trajectory information
; ALL values of n, including initial data
        xsave(n,0:ntraj-1)=xn
        ysave(n,0:ntraj-1)=yn
        psave(n,0:ntraj-1)=pn
;rbp        ssave(n,0:ntraj-1)=sn

        tmpsave(n,0:ntraj-1)=tmpn
; altitude from msf
        altsave(n,0:ntraj-1)=altn
;        pvsave(n,0:ntraj-1)=pvn
;        qdfsave(n,0:ntraj-1)=qdfn
        agesave(n,0:ntraj-1)=agen

        ; extras
        ;;; zsave(n,0:ntraj-1)=zn
        ;;; thsave(n,0:ntraj-1)=thn
        ;;; frdaysave(n,0:ntraj-1)=frday
        ;;; frnghtsave(n,0:ntraj-1)=frnght
        ;;; thdsave(n,0:ntraj-1)=thdn
        ;;; xmsfsave(n,0:ntraj-1)=xmsfn
        ;;; t0save(n,0:ntraj-1)=t0n
        ;;; mintsave(n,0:ntraj-1)=xmintn

; construct and retain maximum PV
        index=where(pvn lt 9999.)
        if (index(0) ne -1) then begin
           temp1 = reform(pvmax(index))
           temp2 = reform(pvn(index))
           temp3 = reform(pn(index))
; look for higher PV values where the parcel is above 500mb level tdf 8/5/2K5
           sel=where(temp2 gt temp1 and temp3 lt 500.,isel)
           if (isel gt 0) then begin
             temp1(sel) = temp2(sel)
             pvmax(index) = temp1
           endif
        endif

; Get convective mass flux (mbar/day) for use as filter
if icmflx lt 0 then stop,'convective mass flux not stored...'
cmflxn = reform(tracern(icmflx,*))*86400.

; construct and maintain marker-derived statistics
;        xmrkn          Marker field: PBL(-1), FT(0), or strat.(1)
;
        index=where(xmrkn ge .99,counts)
        if counts gt 0 then stratsum(index) = stratsum(index)+1.
        index=where(xmrkn lt 0.,countp)
        if countp gt 0 then pblsum(index) = pblsum(index)+1.
;
; regional pbl-influence statistics
;
;        index=where(xmrkn le -.99 or cmflxn ge 10.,countp2)
        index=where(xmrkn lt 0. or cmflxn ge 5.,countp2)
;        index=where(xmrkn le -.99 or (cmflxn ge 5. and altn le 7000.),countp2)
        if countp2 gt 0 then begin
          for idum=0L,countp2-1L do begin
            xtmp = xn(index(idum))
            ytmp = yn(index(idum))
            case 1 of
              xtmp ge 235. and xtmp le 295. and ytmp ge 23. and ytmp le 49.: $
                pblconussum(index(idum)) = pblconussum(index(idum))+1.
              xtmp ge 90. and xtmp le 150. and ytmp ge 10. and ytmp le 45.: $
                pbleasiasum(index(idum)) = pbleasiasum(index(idum))+1.
;              (xtmp ge 345. or xtmp le 30.) and ytmp ge 35. and ytmp le 70.: $
              abs(ytmp) le 15.: $
                pbltropicssum(index(idum)) = pbltropicssum(index(idum))+1.
              else: goto, none
            endcase
            none:
          endfor
        endif
;stop

; Compile time-average quantities
;
;  accumulate sum arrays
        index=where(pvn lt 9999.)
        if (index(0) ne -1) then begin
           pvsum(index)   = pvsum(index)   + pvn(index)
;           qdfsum(index)  = qdfsum(index)  + qdfn(index) 
           number(index)  = number(index)  + 1.0
        endif
        qdfsum = qdfsum + qdfn
        ssum=ssum+sn
        tracersum = tracersum + tracern

;  NOy fractions - note that where NOy=0, zeroes will be averaged in
        sel=where(tracern(inoy,*) gt 0.0 and tracern(inoy,*) lt 9999.,isel)
        if (isel gt 0) then begin
          if ipannoy ge 0 then pannoysum(sel) = $
              pannoysum(sel) + tracern(ipan,sel)/tracern(inoy,sel)
          if inoxnoy ge 0 then noxnoysum(sel) = $
              noxnoysum(sel) + tracern(inox,sel)/tracern(inoy,sel)
        endif
; VOC age diagnostics
;        sel=where(tracern(ipropar,*) gt 0.0 and tracern(ipropar,*) lt 9999. and $
;                  tracern(ic2h6,*) gt 0.0 and tracern(ic2h6,*) lt 9999.,isel)
;        if (isel gt 0) then begin
;          if ivocage ge 0 then vocagesum(sel) = $
;              vocagesum(sel) + (tracern(ipropar,sel)/3.)/tracern(ic2h6,sel)
;        endif

; BIO age diagnostics 
;        sel=where(tracern(ico,*) gt 0.0 and tracern(ico,*) lt 9999.,isel)
;        if (isel gt 0) then begin
;          if ibioage ge 0 then bioagesum(sel) = $
;              bioagesum(sel) + tracern(ich2o,sel)/tracern(ico,sel)
;        endif



        print,' time, n =',n,' summed quantities compiled '
;
;  compute time averages
        index = where (number gt 0.0)
        if (index(0) ne -1) then begin
          pvavesave(n,index)  = pvsum(index) /number(index)
;          qdfavesave(n,index)  = qdfsum(index) /number(index)
        endif
; PV maximum
        pvmaxsave(n,*)   = pvmax
        qdfavesave(n,*)  = qdfsum/float(n+1)
        savesave(n,*)  = ssum/float(n+1)

;
        stratavesave(n,*)  = stratsum/float(n+1)
        pblconusavesave(n,*)  = pblconussum/float(n+1)
        pbltropicsavesave(n,*)  = pbltropicssum/float(n+1)
        pbleasiaavesave(n,*)  = pbleasiasum/float(n+1)
        pblavesave(n,*)  = pblsum/float(n+1)
;
        traceravesave(n,*,*) = tracersum/float(n+1)
;jaa           tracersum is fltarr(ntracers,ntraj)
;jaa           traceravesave is fltarr(nfiles,ntracers,ntraj)*0.0+9999.

        if ipannoy ge 0 then pannoyavesave(n,*) = pannoysum/float(n+1)
        if inoxnoy ge 0 then noxnoyavesave(n,*) = noxnoysum/float(n+1)
;        if ivocage ge 0 then vocageavesave(n,*) = vocagesum/float(n+1)
;        if ibioage ge 0 then bioageavesave(n,*) = bioagesum/float(n+1)

        print,' time, n =',n,' time average arrays updated'
        print,' n =',n,' ntraj =',ntraj

    endfor              ; end of loop over n files

fend: 
print,' end of file found'
times=fix(times)

; make output files

nday=[0,-24,-48,-72,-96,-120]
;nday=[0,-24,-48,-72,-96,-120,-144,-168,-192,-216,-240]

;nday=[0,-24]
nday=[0,-24,-48,-72,-96,-120]
; zero for initial (*diag) conditions


sday=['_0-day','_1-day','_2-day','_3-day','_4-day','_5-day']
sday=['_0-day','_1-day','_2-day','_3-day','_4-day','_5-day',$
      '_6-day','_7-day','_8-day','_9-day','_10-day']

sday=['_5-day']
sday=['_0-day','_1-day','_2-day','_3-day','_4-day','_5-day']

ndays=n_elements(nday)  ; = 11

; initialise curtain arrays

;tdf  I need to save space by making the 4th dimension of "map" arrays
;tdf  equal to ndays(=11) instead of nfiles(=61)     tdf 3/10/2K5

; instantaneous
    xcurt=      9999.+fltarr(nx,ny,nz,ndays)
    ycurt=      9999.+fltarr(nx,ny,nz,ndays)
    pcurt=      9999.+fltarr(nx,ny,nz,ndays)
    scurt=      9999.+fltarr(nx,ny,nz,ndays)
    tmpcurt=    9999.+fltarr(nx,ny,nz,ndays)
    altcurt=    9999.+fltarr(nx,ny,nz,ndays)
;    pvcurt=     9999.+fltarr(nx,ny,nz,ndays)
;    qdfcurt=    9999.+fltarr(nx,ny,nz,ndays)
    agecurt=    9999.+fltarr(nx,ny,nz,ndays)
; time averaged
    pvavecurt=  9999.+fltarr(nx,ny,nz,ndays)
    qdfavecurt= 9999.+fltarr(nx,ny,nz,ndays)
    savecurt= 9999.+fltarr(nx,ny,nz,ndays)

;    pvmaxcurt=  9999.+fltarr(nx,ny,nz,ndays)
    stratcurt=  9999.+fltarr(nx,ny,nz,ndays)
    pblconuscurt=  9999.+fltarr(nx,ny,nz,ndays)
    pbltropicscurt=  9999.+fltarr(nx,ny,nz,ndays)
    pbleasiacurt=  9999.+fltarr(nx,ny,nz,ndays)
    pblcurt=  9999.+fltarr(nx,ny,nz,ndays)

    tracercurt= 9999.+fltarr(ntracerout,nx,ny,nz,ndays)

; extras
;;; zcurt=9999.+fltarr(nx,nz,ndays)
;;; frdaycurt=9999.+fltarr(nx,nz,ndays)
;;; frnghtcurt=9999.+fltarr(nx,nz,ndays)
;;; p0curt=9999.+fltarr(nx,nz,ndays)
;;; fdavecurt=9999.+fltarr(nx,nz,ndays)
;
    for m = 0, ndays-1 do begin
       n=where(times eq nday(m))
       n=n[0]

       print,n,nday(m),times(n)

       ncount=0l
       for i = 0, nx-1 do begin
         for j = 0, ny-1 do begin
           for k = 0, nz-1 do begin

; For regional runs, the trajectory order is consistent with
; regional_fill. For curtain runs, we need to take account
; that parcels are initialised backward in time.

; instantaneous
             xcurt(i,j,k,m)        = xsave(n,ncount)
             ycurt(i,j,k,m)        = ysave(n,ncount)
             pcurt(i,j,k,m)        = psave(n,ncount)
;rbp             scurt(i,j,k,m)        = ssave(n,ncount)
             altcurt(i,j,k,m)      = altsave(n,ncount)
             tmpcurt(i,j,k,m)      = tmpsave(n,ncount)
;             pvcurt(i,j,k,m)       = pvsave(n,ncount)
             agecurt(i,j,k,m)      = agesave(n,ncount)
; time-averaged quantities
             pvavecurt(i,j,k,m)       = pvavesave(n,ncount)
             qdfavecurt(i,j,k,m)   = qdfavesave(n,ncount)
             savecurt(i,j,k,m)   = savesave(n,ncount)

; PV maximum
;             pvmaxcurt(i,j,k,m)    = pvmaxsave(n,ncount)
             stratcurt(i,j,k,m)    = stratavesave(n,ncount)
             pblconuscurt(i,j,k,m)    = pblconusavesave(n,ncount)
             pbltropicscurt(i,j,k,m)    = pbltropicsavesave(n,ncount)
             pbleasiacurt(i,j,k,m)    = pbleasiaavesave(n,ncount)
             pblcurt(i,j,k,m)    = pblavesave(n,ncount)

;;;           traceravesave = fltarr(nfiles,ntracers,ntraj)*0.0+9999.
;;;           oxplavecurt(i,j,k,m)  = traceravesave(n,ioxprod,ncount)

             for itrc=0L,ntracers-1L do begin
               tracercurt(itrc,i,j,k,m) = traceravesave(n,itrc,ncount)
             endfor
             if ipannoy ge 0 then $
               tracercurt(ipannoy,i,j,k,m) = pannoyavesave(n,ncount)
             if inoxnoy ge 0 then $
               tracercurt(inoxnoy,i,j,k,m) = noxnoyavesave(n,ncount)
;             if ivocage ge 0 then $
;               tracercurt(ivocage,i,j,k,m) = vocageavesave(n,ncount)
;             if ibioage ge 0 then $
;               tracercurt(ibioage,i,j,k,m) = bioageavesave(n,ncount)

; change index in map arrays from n to m to reflect dimension ndays
;                                             tdf 3/10/2K5
; extras
;;;    zmap(i,j,k,n)=zsavemn,ncount)
;;;    frdaymap(i,j,k,m)=frdaysave(n,ncount)
;;;    frnghtmap(i,j,k,m)=frnghtsave(n,ncount)
;;;    t0map(i,j,k,m)=t0save(n,ncount)
;;;    fdavemap(i,j,k,m)=fdavesave(n,ncount)

             ncount=ncount+1l
          endfor  ; k loop
         endfor   ; j loop
       endfor     ; i loop
  endfor  ; end of loop over files
;
; Now write output for daily lagrangian average increments
;
  ; save space
  xsave=0.
  ysave=0.
  psave=0.
  tmpsave=0.
  ;qdfsave=0.
  ;pvsave=0.
  altsave=0.
  agesave=0.
  pvmaxsave=0.

  pvavesave=0.
  qdfavesave=0.
  savesave=0.
  tracern=0.
  tracersum=0.
  traceravesave=0.
  pannoyavesave=0.
  noxnoyavesave=0.
  bioageavesave=0.
  vocageavesave=0.


  stratavesave=0.
  pblconusavesave=0.
  pbltropicsavesave=0.
  pbleasiaavesave=0.
  pblavesave=0.

  for m = 0,ndays-1 do begin
    xdum      =reform(xcurt(*,*,*,m),      nx,ny,nz)
    ydum      =reform(ycurt(*,*,*,m),      nx,ny,nz)
    pdum      =reform(pcurt(*,*,*,m),      nx,ny,nz)
;rbp    sdum      =reform(scurt(*,*,*,m),      nx,ny,nz)

    tmpdum    =reform(tmpcurt(*,*,*,m),    nx,ny,nz)
;    pvdum     =reform(pvcurt(*,*,*,m),     nx,ny,nz)
    altdum    =reform(altcurt(*,*,*,m),    nx,ny,nz)
    agedum    =reform(agecurt(*,*,*,m),    nx,ny,nz)

    ; time averaged
    pvavedum  =reform(pvavecurt(*,*,*,m), nx,ny,nz)
    qdfavedum =reform(qdfavecurt(*,*,*,m), nx,ny,nz)
    savedum =reform(savecurt(*,*,*,m), nx,ny,nz)

;    pvmaxdum  =reform(pvmaxcurt(*,*,*,m),  nx,ny,nz)
    stratdum  =reform(stratcurt(*,*,*,m),  nx,ny,nz)
    pblconusdum  =reform(pblconuscurt(*,*,*,m),  nx,ny,nz)
    pbltropicsdum  =reform(pbltropicscurt(*,*,*,m),  nx,ny,nz)
    pbleasiadum  =reform(pbleasiacurt(*,*,*,m),  nx,ny,nz)
    pbldum  =reform(pblcurt(*,*,*,m),  nx,ny,nz)

    tracerdum = reform(tracercurt(*,*,*,*,m), ntracerout,nx,ny,nz)

; now find delta p for files beyond initial day
    if (m eq 0) then begin
      pdldum = pdum*0.0 
      p0dum = pdum
    endif
    if (m gt 0) then pdldum = pdum - p0dum

    print,'max-min(xdum)',max(xdum),min(xdum)
    print,'max-min(ydum)',max(ydum),min(ydum)
    print,'max-min(pdum)',max(pdum),min(pdum)
;rbp    print,'max-min(sdum)',max(sdum),min(sdum)
;    print,'max-min(qdfavedum)',max(qdfavedum),min(qdfavedum)
    print,'max-min(savedum)',max(savedum),min(savedum)

    ;print,'max-min(pvmaxdum)',max(pvmaxdum),min(pvmaxdum)
    print,'max-min(stratdum)',max(stratdum),min(stratdum)
    print,'max-min(pblconusdum)',max(pblconusdum),min(pblconusdum)
    print,'max-min(pbltropicsdum)',max(pbltropicsdum),min(pbltropicsdum)
    print,'max-min(pbleasiadum)',max(pbleasiadum),min(pbleasiadum)
    print,'max-min(pbldum)',max(pbldum),min(pbldum)
    print,'max-min(agedum)',max(agedum),min(agedum)
    print,'max-min(tmpdum)',max(tmpdum),min(tmpdum)
    print,'max-min(pdldum)',max(pdldum),min(pdldum)

    ; output regional run processed data
    xsel=indgen(nx)*ny*nz
    ysel=indgen(ny)*nz
    zsel=indgen(nz)
    ;print,x0(xsel)
    ;print,y0(ysel)
    ;print,z0(zsel)
odir=cdir+'Lagrangian_averaged/'
    openw,20,odir+'rdf_regional_'+label+sday(m)+'.anal.korus-aq.domain.dat',/f77
    print,' writing output to rdf_regional_'+label+sday(m)+'.anal.korus-aq.domain.dat'
    writeu,20,nx,ny,nz,ntracerout
    writeu,20, ih2o, iox, inoy, ipan, inox, ioxprod, iphytndox, iwetdepox, $
     ilnox, icmflx, $
     ico, ibro, iso4, idust, $
     issalt, ibcoc, $
     ipannoy, inoxnoy, ico25d
    writeu,20,x0(xsel),y0(ysel),z0(zsel)
    writeu,20,xdum,ydum,pdum,tmpdum,pvavedum,agedum,$
;     qdfavedum,pvmaxdum,altdum,$
     qdfavedum,savedum,stratdum,pblconusdum,pbltropicsdum,pbleasiadum,pbldum,altdum,$
     tracerdum(*,*,*,*)
    ; Note: tracerdum dimensions are (ntracerout,nx,ny,nz)
    close,20
;
  endfor        ; end of loop over m
  ; Save space
  xcurt=0.
  ycurt=0.
  pcurt=0.
  scurt=0.
  tmpcurt=0.
  altcurt=0.
  agecurt=0.
  pvavecurt=0.
  qdfavecurt=0.
  savecurt=0.
  stratcurt=0.
  pblconuscurt=0.
  pbltropicscurt=0.
  pbleasiacurt=0.
  pblcurt=0.
  tracercurt=0.
  tracerdum=0.

endfor		; loop over RDF runs, nn

close,1
end
