ifile='MA8D_CHLO_9km.CR.timeAverage.0.nc'
nc_file_id=ncdf_open(ifile,/nowrite)
glob_info=ncdf_inquire(nc_file_id)
print,'number of dimensions ',glob_info.ndims
print,'number of variables ',glob_info.nvars
print,'number of attributes ',glob_info.ngatts

; get dimensions
;
for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
;    print,'dimension ',idim,name,dim
    if name eq 'G3fakeDim0' then nlat=dim
    if name eq 'G3fakeDim1' then nlon=dim
endfor
print,nlat,nlon
alat=fltarr(nlat)
alon=fltarr(nlon)
ncdf_varget,nc_file_id,'G3fakeDim0',alat
ncdf_varget,nc_file_id,'G3fakeDim1',alon
;
for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
    print,'variable ',ivar,result.name,result.datatype,result.ndims
endfor
ncdf_varget,nc_file_id,'l3m_data',data
help,data,alon,alat
dummy=alon
alon(0:nlon/2-1)=alon(nlon/2:nlon-1)
alon(nlon/2:nlon-1)=360.+dummy(0:nlon/2-1)
dummy=data
data(0:nlon/2-1,*)=data(nlon/2:nlon-1,*)
data(nlon/2:nlon-1,*)=dummy(0:nlon/2-1,*)

chl=data
clon=alon
clat=alat
;
; close netCDF file
;
ncdf_close,nc_file_id
flname1='A20140012014031.L3m_MO_SST_9.h5'
print,'flname1=',flname1
;
;
; Open an HDF file and and get file ID
print,'flname1=',flname1
file_id=HDF_OPEN(flname1,/READ)

; Get SD interface ID
sd_interface_id=HDF_SD_START(flname1,/READ)

; Get info about the file
;  This returns the number of datasets and user variable attributes
HDF_SD_FILEINFO,sd_interface_id,n_datasets,attributes
print,'n_datasets=',n_datasets
print,'sd_interface_id=',sd_interface_id

; Get info of a given dataset
for i=0,n_datasets-1 do begin
 print,i,sd_interface_id
 si_sds_id=HDF_SD_SELECT(sd_interface_id,i)
 HDF_SD_GETINFO,si_sds_id,HDF_TYPE=si_hdf_type,$
  DIMS=si_dims, NDIMS=si_ndims,NAME=si_name,NATTS=si_natts
 print,i,si_name,si_hdf_type,si_dims,$
  format='(i0,". ",a,t53,a,t65," size: ",5(i0,:,"x"))'
endfor
if n_datasets eq 0 then stop,'no data'
s1_sds_indx=0
print,''
;read,'Enter the index number of datasets ',s1_sds_indx
s1_sds_id = HDF_SD_SELECT(sd_interface_id,s1_sds_indx)
HDF_SD_GETINFO,s1_sds_id,HDF_TYPE=s1_hdf_type,$
 DIMS=s1_dims, NDIMS=s1_ndims,NAME=s1_name,NATTS=s1_natts

; Loop over attributes for the given SDS
for n=1,s1_natts-1 do begin
 HDF_SD_ATTRINFO,s1_sds_id,n,NAME=ss_name,DATA=ss_attr_dat,$
  COUNT=ss_count,HDF_TYPE=ss_hdftype,TYPE=ss_type
  if(ss_name eq 'Fill') then fill_value= ss_attr_dat(0)
  if(ss_name eq 'Scaling')then sfactor= ss_attr_dat(0)
  if(ss_name eq 'Slope')then slope= ss_attr_dat(0)
  if(ss_name eq 'Intercept')then intercept= ss_attr_dat(0)

endfor

; Get data and store in array data
HDF_SD_GETDATA,s1_sds_id,data
 print,s1_name,' Minimum=',Min(data),'  Maximum=',max(data)
help,fill_value,sfactor,slope,intercept
; Close the interface
HDF_SD_ENDACCESS,s1_sds_id
data=intercept+slope*data
sst=data
slon=alon
slat=alat
openr,1,'zsfc.dat',/f77
nc=0l
nr=0l
readu,1,nc,nr
zlon=fltarr(nc)
zlat=fltarr(nr)
readu,1,zlon,zlat
zsfc=fltarr(nc,nr)
readu,1,zsfc
close,1
;
; define 2d lat/lon arrays
;
lon2d=fltarr(nlon,nlat)
lat2d=fltarr(nlon,nlat)
for i=0,nlon-1 do begin
lon2d(i,*)=slon(i)
endfor
for j=0,nlat-1 do begin
lat2d(*,j)=slat(j)
endfor
print,max(sst)
print,min(chl)
index=where(sst eq max(sst))
sst(index)=min(chl)
flag=min(chl)
;
; rebin
;
sst_rebin=flag+0.*zsfc
chl_rebin=flag+0.*zsfc
icount=0l
for i=6,nlon-7,12 do begin
jcount=0l
for j=6,nlat-7,12 do begin
dummy=sst(i-6:i+5,j-6:j+5)
index=where(dummy ne flag)
if index(0) ne -1 then $
sst_rebin(icount,jcount)=total(dummy(index))/n_elements(index)
dummy=chl(i-6:i+5,j-6:j+5)
index=where(dummy ne flag)
if index(0) ne -1 then $
chl_rebin(icount,jcount)=total(dummy(index))/n_elements(index)
print,zlat(jcount),total(slat(j-6:j+5))/12.
jcount=jcount+1l
endfor
print,zlon(icount),total(slon(i-6:i+5))/12.
icount=icount+1l
endfor
help,chl_rebin,sst_rebin
slon=zlon+.5
slat=zlat+.5
;
; interpolate to zsfc grid
;
dummy1a=flag+fltarr(nc,nr)
dummy2a=flag+fltarr(nc,nr)
for j=0,nr-1 do begin
dummy=sst_rebin(*,j)
index=where(dummy ne flag)
if index(0) ne -1 then $
dummy1a(*,j)=interpol(dummy(index),slon(index),zlon)
;
dummy=chl_rebin(*,j)
index=where(dummy ne flag)
if index(0) ne -1 then $
dummy2a(*,j)=interpol(dummy(index),slon(index),zlon)
endfor

dummy1b=flag+fltarr(nc,nr)
dummy2b=flag+fltarr(nc,nr)
for i=0,nc-1 do begin
dummy=dummy1a(i,*)
index=where(dummy ne flag)
if index(0) ne -1 then $
dummy1b(i,*)=interpol(dummy(index),slat(index),zlat)
;
dummy=dummy2a(i,*)
index=where(dummy ne flag)
if index(0) ne -1 then $
dummy2b(i,*)=interpol(dummy(index),slat(index),zlat)
endfor
sst_interp=dummy1b
chl_interp=dummy2b
;
; re-set flag over land
;
index=where(zsfc ge 10.)
sst_interp(index)=flag
chl_interp(index)=flag
openw,1,'sst.interp.dat',/f77
writeu,1,nc,nr
writeu,1,zlon,zlat
writeu,1,sst_interp
close,1
openw,1,'chl.interp.dat',/f77
writeu,1,nc,nr
writeu,1,zlon,zlat
writeu,1,chl_interp
close,1

end

