      subroutine define_tracers
      include 'comm_uwhyb_3d_v24_gentracer.'

c Local variables
      logical do_q, do_ox, do_noy, do_pan, do_nox,
     & do_oxprod, do_phyox, do_wetox, do_dms, do_ch2o,
     & do_lightnoy,
     & do_cmflx,
     & do_co, do_bro, do_so4, do_dust,
     & do_ssalt, do_bcoc, do_co25d

      idq=0
      idox=0
      idnoy=0
      idpan=0
      idnox=0
      idoxprod=0
      idphyox=0
      idwetox=0
      iddms=0
      idch2o=0
      idlightnoy=0
      idcmflx=0
      idco=0
      idbro=0
      idso4=0
      iddust=0
      idssalt=0
      idbcoc=0
      idco25d=0
c
c Define tracers for this simulation - total number "true" must be less than
c  or equal to the parameter ntracersmx, defined in the include 'comm' file
c
      do_q = .true.
      do_ox = .true.
      do_noy = .true.
      do_pan = .true.
      do_nox = .true.
      do_oxprod = .true.
      do_phyox = .true.
      do_wetox = .true.
      do_dms = .true.
      do_ch2o = .true.
      do_lightnoy = .true.
      do_cmflx = .true.
      do_co = .true.
      do_bro = .true.
      do_so4 = .true.
      do_dust = .true.
      do_ssalt = .true.
      do_bcoc = .true.
      do_co25d = .true.

      i = 0
      if(do_q) then
        i = i+1
        idq = i
        tracername(idq) = 'iq'
        trstrlen(idq) = 2
      endif
      if(do_ox) then
        i = i+1
        idox = i
        tracername(idox) = 'iox'
        trstrlen(idox) = 3
      endif
      if(do_noy) then
        i = i+1
        idnoy = i
        tracername(idnoy) = 'inoy'
        trstrlen(idnoy) = 4
      endif
      if(do_pan) then
        i = i+1
        idpan = i
        tracername(idpan) = 'ipan'
        trstrlen(idpan) = 4
      endif
      if(do_nox) then
        i = i+1
        idnox = i
        tracername(idnox) = 'inox'
        trstrlen(idnox) = 4
      endif
      if(do_oxprod) then
        i = i+1
        idoxprod = i
        tracername(idoxprod) = 'oxprod'
        trstrlen(idoxprod) = 6
      endif
      if(do_phyox) then
        i = i+1
        idphyox = i
        tracername(idphyox) = 'phytndox'
        trstrlen(idphyox) = 8
      endif
      if(do_wetox) then
        i = i+1
        idwetox = i
        tracername(idwetox) = 'wetdepox'
        trstrlen(idwetox) = 8
      endif
      if(do_dms) then
        i = i+1
        iddms = i
        tracername(iddms) = 'idms'
        trstrlen(iddms) = 4
      endif
      if(do_ch2o) then
        i = i+1
        idch2o = i
        tracername(idch2o) = 'ich2o'
        trstrlen(idch2o) = 5
      endif
      if(do_lightnoy) then
        i = i+1
        idlightnoy = i
        tracername(idlightnoy) = 'lnox'
        trstrlen(idlightnoy) = 4
      endif
      if(do_cmflx) then
        i = i+1
        idcmflx = i
        tracername(idcmflx) = 'cmflx'
        trstrlen(idcmflx) = 5
      endif
      if(do_co) then
        i = i+1
        idco = i
        tracername(idco) = 'ico'
        trstrlen(idco) = 3
      endif
      if(do_bro) then
        i = i+1
        idbro = i
        tracername(idbro) = 'bro'
        trstrlen(idbro) = 3
      endif
      if(do_so4) then
        i = i+1
        idso4 = i
        tracername(idso4) = 'iso4aer'
        trstrlen(idso4) = 7
      endif
      if(do_dust) then
        i = i+1
        iddust = i
        tracername(iddust) = 'idust'
        trstrlen(iddust) = 5
      endif
      if(do_ssalt) then
        i = i+1
        idssalt = i
        tracername(idssalt) = 'issalt'
        trstrlen(idssalt) = 6
      endif
      if(do_bcoc) then
        i = i+1
        idbcoc = i
        tracername(idbcoc) = 'ibcoc'
        trstrlen(idbcoc) = 5
      endif
      if(do_co25d) then
        i = i+1
        idco25d = i
        tracername(idco25d) = 'ico25d'
        trstrlen(idco25d) = 6
      endif
        write(6,*) 'In tracer setup, subroutine define_tracers'
        write(6,*) ' # tracers '
        write(6,*) i,ntracersmx



      if(i.gt.ntracersmx) then
        write(6,*) 'Incorrect tracer setup, subroutine define_tracers'
        write(6,*) ' # tracers defined greater than ntracersmx'
        write(6,*) i,ntracersmx
        stop
      endif

      ntracers=i

      return
      end
